<template>
  <div class="main-contain">
    <div class="position">
      <bread-crumb
        v-if="this.$route.query.type == 1"
        :crumbs="crumbs"
      ></bread-crumb>
      <bread-crumb
        v-if="this.$route.query.type == 2"
        :crumbs="crumbs2"
      ></bread-crumb>

      <div style="float:right;">
        <el-button size="small" @click="back()" class="filter-item"
          >取 消</el-button
        >
        <el-button
          size="small"
          type="primary"
          @click="submit()"
          class="filter-item"
          >保 存</el-button
        >
      </div>
    </div>

    <div class="app-container">

      <!--<stock-in-dialog-->
        <!--ref="dialog"-->
        <!--:propForm="propForm"-->
        <!--:visibility="isVisibility"-->
        <!--v-on:dialog-comfirm="comfirm"-->
        <!--v-on:dialog-cancle="cancle"-->
      <!--&gt;</stock-in-dialog>-->
      <drugs-stock-dialog
        ref="dialog"
        :propForm="propForm"
        :visibility="isVisibility"
        v-on:dialog-comfirm="comfirm"
        v-on:dialog-cancle="cancle"
      >

      </drugs-stock-dialog>

      <div class="filter-container">
        <div class="cell clearfix">
          <label class="title"><span class="name">退库时间</span> : </label>

          <el-date-picker
            size="small"
            v-model="return_time"
            prefix-icon="el-icon-date"
            :editable="false"
            style="width: 196px;"
            type="date"
            placeholder="选择日期时间"
            align="right"
            format="yyyy-MM-dd"
            value-format="yyyy-MM-dd"
          ></el-date-picker>
        </div>

        <div class="cell clearfix">
          <label class="title"><span class="name">经销商</span> : </label>
          <el-select
            size="small"
            v-model="form.dealer"
            clearable
            placeholder="请选择经销商"
            @change="changeDealer"
          >
            <el-option
              v-for="(option, index) in dealer"
              :key="index"
              :label="option.dealer_name"
              :value="option.id"
            >
            </el-option>
          </el-select>
        </div>

        <div class="cell clearfix">
          <label class="title"><span class="name">厂商</span> : </label>
          <el-select
            size="small"
            v-model="form.manufacturer"
            clearable
            placeholder="请选择厂商"
            @change="changeManufacturer"
          >
            <el-option
              v-for="(option, index) in manufacturer"
              :key="index"
              :label="option.manufacturer_name"
              :value="option.id"
            >
            </el-option>
          </el-select>
        </div>
      </div>

      <el-form :rules="tableRules" :model="recordInfo" ref="tableForm">
        <el-table
          :data="recordInfo.recordData"
          :class="signAndWeighBoxPatients"
          style="width: 100%"
          border
          max-height="450"
          :header-cell-style="{ backgroundColor: 'rgb(245, 247, 250)' }"
        >
          <el-table-column min-width="35" align="center">
            <template slot="header" slot-scope="scope">
              <span>商品类型<span style="color: red">*</span></span>
            </template>

            <template slot-scope="scope">
              <!--<span @click="showDialog(scope.$index, scope.row)" v-if="scope.row.good_type_id == 0" style="color:#c5c8cf">请输入类型</span>-->
              <!--<span @click="showDialog(scope.$index, scope.row)" v-if="scope.row.good_type_id != 0">{{typeName(scope.row.good_type_id)}}</span>-->

              <el-form-item style="padding-top: 15px">
                <el-input
                  placeholder="请输入药品名称"
                  v-model="scope.row.drug_id"
                  :value="typeName(scope.row.drug_id)"
                  @focus="showDialog(scope.$index, scope.row)"
                ></el-input>
              </el-form-item>
            </template>
          </el-table-column>
          <el-table-column min-width="35" align="center">
            <template slot="header" slot-scope="scope">
              <span>规格名称<span style="color: red">*</span></span>
            </template>
            <template slot-scope="scope">
              <el-form-item style="padding-top: 15px">
                <el-input
                  placeholder="请输入规格名称"
                  v-model="scope.row.drug_id"
                  :value="specificationName(scope.row.drug_id)"
                  @focus="showDialog(scope.$index, scope.row)"
                ></el-input>
              </el-form-item>
            </template>
          </el-table-column>

          <el-table-column align="center" width="150">
            <template slot="header" slot-scope="scope">
              <span>进价<span style="color: red">*</span></span>
            </template>
            <template slot-scope="scope">
              <!--<el-input type="number" v-model="scope.row.price"  @blur="handleBlur(scope.$index, scope.row)"></el-input>-->
              <el-form-item
                :prop="'recordData.' + scope.$index + '.price'"
                :rules="tableRules.price"
                style="padding-top: 17px"
              >
                <el-input
                  placeholder="请输入单价"
                  type="number"
                  v-model="scope.row.price"
                ></el-input>
              </el-form-item>
            </template>
          </el-table-column>


          <el-table-column min-width="23" align="center">
            <template slot="header" slot-scope="scope">
              <span>退库数量<span style="color: red">*</span></span>
            </template>
            <template slot-scope="scope">
              <el-form-item
                :prop="'recordData.' + scope.$index + '.return_count'"
                :rules="tableRules.return_count"
                style="padding-top: 17px"
              >
                <el-input
                  placeholder="请输入退库数量"
                  type="number"
                  v-model="scope.row.return_count"
                ></el-input>
              </el-form-item>
            </template>
          </el-table-column>

          <el-table-column label="进价总价" align="center" width="150">
            <template slot-scope="scope">
              {{ calculate(scope.row.price * scope.row.return_count) }}
            </template>
          </el-table-column>


          <el-table-column label="零价" align="center" width="150">
            <template slot-scope="scope">
              {{ scope.row.retail_price }}
            </template>
          </el-table-column>

          <el-table-column label="零价总价" align="center" width="150">
            <template slot-scope="scope">
              {{ calculate(scope.row.retail_price * scope.row.return_count) }}
            </template>
          </el-table-column>
          <el-table-column label="操作" align="center" min-width="20">
            <template slot-scope="scope">
              <el-tooltip
                class="item"
                effect="dark"
                content="新增"
                placement="top"
              >
                <el-button
                  size="mini"
                  type="primary"
                  icon="el-icon-circle-plus-outline"
                  @click="handleEdit(scope.$index, scope.row)"
                >
                </el-button>
              </el-tooltip>
              <el-tooltip
                class="item"
                effect="dark"
                content="删除"
                placement="top"
              >
                <el-button
                  size="mini"
                  type="danger"
                  icon="el-icon-delete"
                  @click="handleDelete(scope.$index, scope.row)"
                >
                </el-button>
              </el-tooltip>
            </template>
          </el-table-column>
        </el-table>
      </el-form>
    </div>
  </div>
</template>

<script>
import { uParseTime } from "@/utils/tools";
import {  postDrugCancelStock,GetAllConfig,GetAllDrugInfoByID } from "@/api/drug/drug_stock";
import BreadCrumb from "../../components/bread-crumb";
import DrugsStockDialog from './drugsStockDialog/index'

export default {
  components: { DrugsStockDialog, BreadCrumb },
  name: "salesReturnOrderAdd",

  data() {
    return {
      crumbs: [
        { path: false, name: "库存管理" },
        { path: false, name: "耗材退库单" },
        { path: false, name: "新增退库单" }
      ],
      crumbs2: [
        { path: false, name: "库存管理" },
        { path: false, name: "其他退库单" },
        { path: false, name: "新增退库单" }
      ],

      type: this.$route.query.type,
      signAndWeighBoxPatients: "sign-and-weigh-box-patients",
      return_time: "",
      currentIndex: 0,
      recordInfo: {
        recordData: []
      },
      tableRules: {
        return_count: [
          { required: true, message: "数量不能为空", trigge: "blur" }
        ]
      },
      ruleForm: {
        manufacturer: [
          { required: true, message: "请选择厂商", trigger: "change" }
        ]
      },
      // prop
      isVisibility: false,
      propForm: {
        goods: [],
        goodType: [],
        goodInfo: [],
        goodUnit: [],
        manufacturer: 0,
        dealer: 0
      },
      form: {
        manufacturer: 0,
        dealer: 0
      },
      warehouseOutInfoList: [],
      manufacturer: [],
      dealer: [],
      goodType: [],
      goodInfo:[],
    };
  },
  methods: {
    comfirm: function(val) {
      this.propForm.goodType = []
      this.propForm.goods = []

      this.$refs.dialog.hide()
      if (val.selectedGoodInfo.length > 0) {
        for (let i = val.selectedGoodInfo.length - 1; i >= 0; i--) {
          if (i == 0) {
            this.recordInfo.recordData[this.currentIndex].drug_id = val.selectedGoodInfo[i].id
            this.recordInfo.recordData[this.currentIndex].price = val.selectedGoodInfo[i].last_price.toString();
            this.recordInfo.recordData[this.currentIndex].retail_price = val.selectedGoodInfo[i].retail_price.toString();
          } else {
            const tempForm = {}
            tempForm['drug_id'] = val.selectedGoodInfo[i].id
            tempForm["return_count"] = "";
            tempForm["price"] = val.selectedGoodInfo[i].last_price.toString();
            tempForm["retail_price"] =  val.selectedGoodInfo[i].retail_price.toString();
            this.recordInfo.recordData.splice(this.currentIndex + 1, 0, tempForm)
          }
        }
      }
      this.currentIndex = -1
    },

    cancle: function() {
      this.$refs.dialog.hide();
    },
    GetConfigInfo: function() {
      const loading = this.$loading({
        lock: true,
        text: 'Loading',
        spinner: 'el-icon-loading',
        background: 'rgba(0, 0, 0, 0.7)'
      })

      GetAllConfig().then(response => {
        if (response.data.state == 0) {
          this.$message.error(response.data.msg)
          return false
        } else {
          this.manufacturer = response.data.data.manufacturer;
          this.dealer = response.data.data.dealer;
          for(let i = 0; i<  response.data.data.drugs.length;i++){
            this.goodType.push(response.data.data.drugs[i])
            if(response.data.data.drugs[i].drug_specs != null) {
              for (let b = 0; b < response.data.data.drugs[i].drug_specs.length; b++) {
                this.goodInfo.push(response.data.data.drugs[i].drug_specs[b])
              }
            }
          }
          this.manufacturer.splice(0, 0, { id: 0, manufacturer_name: "全部" });
          this.dealer.splice(0, 0, { id: 0, dealer_name: "全部" });

          this.form.manufacturer = 0
          this.form.dealer = 0
        }
        loading.close()
      })

    },

    typeName: function(drug_id) {
      let name = "";
      for (let i = 0; i < this.goodInfo.length; i++) {
        if (this.goodInfo[i].id == drug_id) {
          name = this.goodInfo[i].drug_name;

        }
      }
      return name;
    },
    specificationName: function(drug_id) {
      let name = "";
      for (let i = 0; i < this.goodInfo.length; i++) {
        if (this.goodInfo[i].id == drug_id) {
          name = this.goodInfo[i].drug_spec;
        }
      }
      return name;
    },
    handleEdit: function(index, row) {
      const tempObj = {};
      tempObj["drug_id"] = 0;
      tempObj["return_count"] = "";
      tempObj["price"] = "";
      tempObj["retail_price"] = "";

      this.recordInfo.recordData.push(tempObj);
    },
    handleDelete: function(index, row) {
      if (this.recordInfo.recordData.length <= 1) {
        this.$message.error("只有一条记录的时候无法删除");
        return;
      } else {
        this.recordInfo.recordData.splice(index, 1);
      }
    },
    calculate: function(val) {
      if (val == 0) {
        return "";
      }

      return Math.round(parseFloat(val) * 100) / 100;
    },
    getTime(val, temp) {
      if (val != 0) {
        return uParseTime(val, temp);
      } else {
        return "";
      }
    },
    showDialog(index, row) {
      const loading = this.$loading({
        lock: true,
        text: 'Loading',
        spinner: 'el-icon-loading',
        background: 'rgba(0, 0, 0, 0.7)'
      })
      this.currentIndex = index
      this.isVisibility = true
      const params = {
        manufacturer_id: this.form.manufacturer,
        dealer_id: this.form.dealer
      }
      GetAllDrugInfoByID(params).then(response => {
          if (response.data.state == 0) {
            this.$message.error(response.data.msg)
            return false
            loading.close()

          } else {
            loading.close()

            if (response.data.data.drugs.length <= 0) {
              this.$message.error('该厂商或经销商没有药品信息')
              return
            }
            this.$refs.dialog.show()
            for (let i = 0; i < response.data.data.drugs.length; i++) {
              this.propForm.goods.push(
                response.data.data.drugs[i]
              );
            }
            const obj = {};
            this.propForm.goods = this.propForm.goods.reduce(
              (cur, next) => {
                obj[next.id] ? "" : (obj[next.id] = true && cur.push(next));
                return cur;
              },
              []
            ); // 设置cur默认类型为数组，并且初始值为空的数组
          }

        for (let i = 0; i < this.propForm.goods.length; i++) {
          for (let a = 0; a < this.propForm.goods[i].drug_specs.length; a++) {
            var respObj = this.propForm.goods[i].drug_specs[a];
            respObj["isSelected"] = false;
          }
        }
        }
      )
    },

    back() {
      this.$router.go(-1);
    },
    submit() {
      this.$refs["tableForm"].validate(valid => {
        if (valid) {
          const array = this.recordInfo.recordData;
          let total = 0;
          for (let i = 0; i < array.length; i++) {

            if (array[i].drug_id == 0) {
              this.$message.error("药品名称或者药品规格名称不能为空");
              return;
            }
            total = total + array[i].price * array[i].return_count;
          }

          if (this.recordInfo.recordData.length <= 0) {
            this.$message.success("请添加退库商品");
            return;
          }

          const params = {
            cancelStock: this.recordInfo.recordData
          };
          postDrugCancelStock(
            params,
            this.return_time,
            this.form.manufacturer,
            this.form.dealer,
            this.type
          ).then(response => {
            if (response.data.state == 0) {
              this.$message.error(response.data.msg);
              return false;
            } else {
              this.$notify({
                title: "成功",
                message: "退库成功",
                type: "success",
                duration: 2000
              });
              this.recordInfo.recordData = [];
              this.$router.back(-1);
            }
          });
        } else {
          return false;
        }
      });
    },
    changeManufacturer(val) {
      this.propForm.manufacturer = val;
    },
    changeDealer(val) {
      this.propForm.dealer = val;
    }
  },
  created() {
    var nowDate = new Date();
    var nowYear = nowDate.getFullYear();
    var nowMonth = nowDate.getMonth() + 1;
    var nowDay = nowDate.getDate();
    this.return_time =
      nowYear +
      "-" +
      (nowMonth < 10 ? "0" + nowMonth : nowMonth) +
      "-" +
      (nowDay < 10 ? "0" + nowDay : nowDay);

    const tempObj = {};
    tempObj["good_type_id"] = 0;
    tempObj["good_id"] = 0;
    tempObj["return_count"] = "";
    tempObj["price"] = "";
    tempObj["retail_price"] = "";


    this.recordInfo.recordData.push(tempObj);
    this.GetConfigInfo();
    this.propForm.goodUnit = this.$store.getters.good_unit;
  }
};
</script>

<style rel="stylesheet/css" lang="scss" scoped>
.information {
  border: 1px #dcdfe6 solid;
  padding: 30px 20px 30px 20px;

  .border {
    border-bottom: 1px #dcdfe6 solid;
    margin: 0px 0 20px 0;
  }
}

.edit_separater {
  border-top: 1px solid rgb(233, 233, 233);
  margin-top: 15px;
  margin-bottom: 15px;
}
</style>

<style>
.sign-and-weigh-box .sign-and-weigh-box-patients .cell {
  font-size: 12px;
}

.sign-and-weigh-box .sign-and-weigh-box-patients .current-row > td {
  background: #6fb5fa;
}
</style>
